=== debian/changelog ===
rz-ghidra (0.6.0-0parrot1) lory; urgency=medium

  * Rebuild for Parrot 6.0.

 -- Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>  Fri, 08 Sep 2023 17:08:12 +0200

rz-ghidra (0.6.0-0kali1) kali-dev; urgency=medium

  * New upstream version 0.6.0
  * Add required version of rizin and rizin-cutter in build-dep
  * d/watch: download tarball with all sources
  * Update lintian-overrides
  * Add missing doc information

 -- Sophie Brun <sophie@offensive-security.com>  Mon, 21 Aug 2023 16:29:39 +0200

rz-ghidra (0.5.0-0kali1) kali-dev; urgency=medium

  * New upstream version 0.5.0

 -- Sophie Brun <sophie@offensive-security.com>  Fri, 09 Jun 2023 11:05:41 +0200

rz-ghidra (0.4.0-0kali3) kali-dev; urgency=medium

  * Add superficial test
  * Disable CI build for armel

 -- Arnaud Rebillout <arnaudr@kali.org>  Wed, 12 Apr 2023 11:31:27 +0700

rz-ghidra (0.4.0-0kali2) kali-dev; urgency=medium

  * Fix architecture-specific path in d/rules

 -- Arnaud Rebillout <arnaudr@kali.org>  Mon, 20 Mar 2023 13:10:04 +0700

rz-ghidra (0.4.0-0kali1) kali-dev; urgency=medium

  [ Daniele Faugiana ]
  * Initial release

  [ Arnaud Rebillout ]
  * Review and minor changes

 -- Arnaud Rebillout <arnaudr@kali.org>  Mon, 20 Mar 2023 08:45:01 +0700
