=== debian/changelog ===
rz-ghidra (0.8.0-0kali1) kali-dev; urgency=medium

  [ Steev Klimaszewski ]
  * d/upstream: Add upstream metadata

  [ Sophie Brun ]
  * New upstream version 0.8.0
  * Update build-depends

 -- Sophie Brun <sophie@offensive-security.com>  Wed, 07 May 2025 10:34:58 +0200

rz-ghidra (0.7.0-0kali1) kali-dev; urgency=medium

  * New upstream version 0.7.0
  * Update minimal version of librizin-dev
  * Update minimal required version of rizin-cutter

 -- Sophie Brun <sophie@offensive-security.com>  Thu, 07 Mar 2024 14:05:36 +0100
