=== debian/control ===
--- 
+++ 
@@ -1,19 +1,22 @@
 Source: rz-ghidra
 Section: misc
 Priority: optional
-Maintainer: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
-Uploaders: Lorenzo "Palinuro" Faletra <palinuro@parrotsec.org>
+Maintainer: Kali Developers <devel@kali.org>
+Uploaders: Daniele Faugiana <dani.faugiana@gmail.com>
 Rules-Requires-Root: no
 Build-Depends:
  cmake,
  debhelper-compat (= 13),
- libqt5svg5-dev,
- librizin-cutter-dev (>= 2.3.0),
- librizin-dev (>= 0.6.0),
- qtbase5-dev,
+ libqt6svg6-dev,
+ librizin-cutter-dev (>= 2.4.0),
+ librizin-dev (>= 0.8.0),
+ qt6-5compat-dev,
+ qt6-base-dev,
  rizin-cutter,
 Standards-Version: 4.6.2
 Homepage: https://github.com/rizinorg/rz-ghidra
+Vcs-Browser: https://gitlab.com/kalilinux/packages/rz-ghidra
+Vcs-Git: https://gitlab.com/kalilinux/packages/rz-ghidra.git
 
 Package: rz-ghidra
 Architecture: amd64 arm64 armhf i386 mipsel
