=== debian/rules ===
#!/usr/bin/make -f

# See debhelper(7) (uncomment to enable).
# Output every command that modifies files on the build system.
export DH_VERBOSE = 1

# See FEATURE AREAS in dpkg-buildflags(1).
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# See ENVIRONMENT in dpkg-buildflags(1).
# Package maintainers to append CFLAGS.
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# Package maintainers to append LDFLAGS.
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

include /usr/share/dpkg/architecture.mk

%:
	dh $@ --buildsystem=cmake --sourcedirectory=.

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DBUILD_CUTTER_PLUGIN=ON \
	    -DBUILD_SLEIGH_PLUGIN=ON \
	    -DCMAKE_INSTALL_PREFIX=/usr \
	    -DRIZIN_INSTALL_PLUGDIR=/usr/lib/rizin/plugins \
	    -DCUTTER_INSTALL_PLUGDIR=/usr/lib/rizin/cutter/plugins/native

execute_after_dh_auto_install:
	rm -fr debian/rz-ghidra/usr/include
	rm -fr debian/rz-ghidra/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig
	rmdir --ignore-fail-on-non-empty debian/rz-ghidra/usr/lib/$(DEB_HOST_MULTIARCH)
