=== debian/tests/control ===
Test-Command: rizin -q -c "e asm.arch=?" | grep -q "^ghidra$"
Depends: @, rizin
Restrictions: superficial
