=== debian/watch ===
version=4
opts="\
dversionmangle=auto,\
uversionmangle=s{(\d)[\-]?(rc\d*)$}{$1~$2},\
filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%,\
downloadurlmangle=s%/archive/refs/tags/(.*).tar.gz%/releases/download/$1/rz-ghidra-src-$1.tar.gz%\
" https://github.com/rizinorg/rz-ghidra/tags \
  (?:.*?/)?v@ANY_VERSION@@ARCHIVE_EXT@
